/*
 *  MGRTObject.cpp
 *  MySQL GRT
 *
 *  Created by Alfredo Kojima on 05/8/17.
 *  Copyright 2005 MySQL AB. All rights reserved.
 *
 */

#include "MGRTObject.h"


MGRTObject::MGRTObject(MYX_GRT *grt, MYX_GRT_VALUE *object)
: _grt(grt), _original(object), _object(myx_grt_value_dup(object))
{
  myx_grt_value_release(_object.grtValue());
}

MGRTObject::~MGRTObject()
{
}

void MGRTObject::revert()
{
  _object.assign(MGRTValue(myx_grt_value_dup(_original.grtValue())));
  myx_grt_value_release(_object.grtValue());
}


void MGRTObject::commit()
{
  MYX_GRT_VALUE *diff;
  
  diff= myx_grt_value_diff_make(_grt, _original.grtValue(), _object.grtValue());
  
  myx_grt_value_diff_apply(_grt, _original.grtValue(), diff);
  
  myx_grt_value_release(diff);
}
