/* MTableEditor */

#import <Cocoa/Cocoa.h>
#include <myx_public_interface.h>
#include <MySQLGRT/myx_grt_public_interface.h>
#include <MySQLGRT/MGRTTable.h>
#import <MySQLGRT/MGRT.h>

extern NSString *MTableEditorTableDidChange;

@class MAccessoryScrollView;

@interface MGRTTableEditor : NSWindowController
{
    IBOutlet NSPopUpButton *colCharsetPop;
    IBOutlet NSPopUpButton *colCollationPop;
    IBOutlet NSTextView *colCommentText;
    IBOutlet NSTextField *colDefaultText;
    IBOutlet NSButton *colDefaultNull;
    IBOutlet NSTableView *colFlagsList;
    IBOutlet NSView *colGroup;
    IBOutlet NSTextField *colNameText;
    IBOutlet NSButtonCell *colAIncCheck;
    IBOutlet NSButtonCell *colUniqueCheck;
    IBOutlet NSButtonCell *colNNullCheck;
    IBOutlet NSButtonCell *colPKCheck;
    IBOutlet NSComboBox *colTypeCombo;
    IBOutlet NSTableView *columnList;
    IBOutlet NSTextField *commentText;
    IBOutlet NSMatrix *engineMatrix;
    IBOutlet NSView *fkContainer;
    IBOutlet NSBox *fkBox;
    IBOutlet NSTableView *fkColumnList;
    IBOutlet NSTableView *fkList;
    IBOutlet NSTextField *fkNameText;
    IBOutlet NSPopUpButton *fkOnDeletePop;
    IBOutlet NSPopUpButton *fkOnUpdatePop;
    IBOutlet NSPopUpButton *fkRefTablePop;
    IBOutlet NSBox *indBox;
    IBOutlet NSTableView *indColumnList;
    IBOutlet NSTableView *indexList;
    IBOutlet NSPopUpButton *indKindPop;
    IBOutlet NSTextField *indNameText;
    IBOutlet NSPopUpButton *indTypePop;
    IBOutlet NSPopUpButton *schemaPop;
    IBOutlet NSTextField *tableNameText;
    IBOutlet NSPopUpButton *tblCharsetPop;
    IBOutlet NSPopUpButton *tblCollationPop;
    IBOutlet NSView *miscOpView;
    IBOutlet NSView *rowOpView;
    IBOutlet NSView *stoOpView;
    IBOutlet NSView *mergeOpView;
    IBOutlet NSView *raidOpView;
    
    IBOutlet NSPanel *confirmPanel;
    IBOutlet NSTextView *confirmText;
    
    MYSQL *_mysql;
    MGRT *_grt;
    MGRTValue *_catalogs;
    MGRTTable *_tableData;
        
    NSImage *_pkIcon;
    NSImage *_columnIcon;
    NSImage *_blobIcon;
    NSImage *_dateIcon;
    NSImage *_numericIcon;
    NSImage *_spatialIcon;
    NSImage *_stringIcon;
    NSImage *_userdefIcon;
  
    NSImage *_nullIcon;
    
    int _draggedRow;
    
    BOOL _releaseOnClose;
}
- (IBAction)applyChanges:(id)sender;
- (IBAction)close:(id)sender;
- (IBAction)discardChanges:(id)sender;
- (IBAction)chooseFile:(id)sender;
- (IBAction)handleValueChange:(id)sender;
- (IBAction)handleColumnValueChange:(id)sender;
- (IBAction)handleIndexValueChange:(id)sender;
- (IBAction)handleFKValueChange:(id)sender;
- (IBAction)confirmSave:(id)sender;
- (IBAction)confirmCancel:(id)sender;
- (IBAction)confirmOK:(id)sender;

- (void)setGRT:(MGRT*)grt catalogs:(MGRTValue)catalogs;

- (void)setReleaseOnClose:(BOOL)flag;

- (void)editObject:(MYX_GRT_VALUE*)value;

@end

#ifdef __cplusplus
extern "C" {
#endif
MYX_GRT_VALUE *grt_openTableEditor(MYX_GRT_VALUE *arg, void *udata);
#ifdef __cplusplus
};
#endif


