unit MyxTableEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ImgList, ExtCtrls, TntExtCtrls, Buttons, TntButtons, StdCtrls,
  TntStdCtrls, CheckLst, TntCheckLst, VirtualTrees, ComCtrls, TntComCtrls,
  MyxEditor, TntForms, TntClasses, AuxFuncs, PngImage, PngTools,
  MyxTableEditorVTEdit, MyxAppOptions, ActiveX;

type
  RdbmsDatatypeGroup = (
    RDG_NUMERIC = 0,
    RDG_STRING,
    RDG_TEXT,
    RDG_BLOB,
    RDG_DATETIME,
    RDG_GEO,
    RDG_VARIOUS,
    RDG_USER,
    RDG_STRUCTURED
  );

  PColumnNodeData = ^TColumnNodeData;
  TColumnNodeData = record
    Column: Pointer;
    SimpleDatatype,
    StructuredDatatype: Pointer;
    Caption,
    DatatypeFullCaption,
    Default,
    Comment: WideString;
    PrimaryKey,
    ForeignKey,
    NotNull,
    AutoIncrement,
    DefaultIsNull: Boolean;
    DatatypeGroup: RdbmsDatatypeGroup;
    DatatypeFlags: TTntStringList;
    ColumnFlags: TTntStringList;
  end;

  TMyxTableEditorForm = class(TMyxEditorForm)
    DockPanel: TTntPanel;
    HeaderPnl: TTntPanel;
    TableNameLbl: TTntLabel;
    TntLabel3: TTntLabel;
    TableNameEd: TTntEdit;
    LeftPnl: TTntPanel;
    RightPnl: TTntPanel;
    BottomPnl: TTntPanel;
    DiscardChangesBtn: TTntButton;
    ApplyChangesBtn: TTntButton;
    TntPageControl1: TTntPageControl;
    ColumnSheet: TTntTabSheet;
    ColumnsPageControl: TTntPageControl;
    TntTabSheet2: TTntTabSheet;
    AddIndexBtn: TTntSpeedButton;
    DeleteIndexBtn: TTntSpeedButton;
    IndexVST: TVirtualStringTree;
    TntGroupBox1: TTntGroupBox;
    IndexNameLbl: TTntLabel;
    IndexKindLbl: TTntLabel;
    TntLabel12: TTntLabel;
    IndexTypeLbl: TTntLabel;
    AddIndexColumnBtn: TTntSpeedButton;
    DeleteIndexColumnBtn: TTntSpeedButton;
    AdvIndexColumnBtn: TTntSpeedButton;
    TntLabel9: TTntLabel;
    IndexNameEd: TTntEdit;
    IndexKindCBox: TTntComboBox;
    IndexColumnsListBox: TTntListBox;
    IndexTypeCBox: TTntComboBox;
    TntTabSheet8: TTntTabSheet;
    AddFKBtn: TTntSpeedButton;
    DropFKBtn: TTntSpeedButton;
    TntGroupBox2: TTntGroupBox;
    TntLabel14: TTntLabel;
    TntLabel15: TTntLabel;
    TntLabel16: TTntLabel;
    TntLabel17: TTntLabel;
    FKNameEd: TTntEdit;
    FKOnDeleteComboBox: TTntComboBox;
    FKColsVST: TVirtualStringTree;
    FKOnUpdateComboBox: TTntComboBox;
    FKDestTablesComboBox: TTntComboBox;
    FKVST: TVirtualStringTree;
    TntTabSheet3: TTntTabSheet;
    TntLabel4: TTntLabel;
    TntLabel5: TTntLabel;
    TntLabel6: TTntLabel;
    TntLabel7: TTntLabel;
    TntLabel8: TTntLabel;
    TntLabel36: TTntLabel;
    TntLabel37: TTntLabel;
    ColumnNameEd: TTntEdit;
    ColumnDatatypeEd: TTntEdit;
    ColumnFlagsCheckListBox: TTntCheckListBox;
    ColumnCommentMemo: TTntMemo;
    ColumnDefaultValueEd: TTntEdit;
    ColumnCharsetCBox: TTntComboBox;
    ColumnCollateCBox: TTntComboBox;
    TntGroupBox5: TTntGroupBox;
    ColumnPKCBox: TTntCheckBox;
    ColumnNotNullCBox: TTntCheckBox;
    ColumnAutoIncCBox: TTntCheckBox;
    SetDefValNullBtn: TTntBitBtn;
    ColumnVST: TVirtualStringTree;
    ColumnOptionSplitter: TTntSplitter;
    ColumnImgList: TImageList;
    ColumnHeaderImgList: TImageList;
    TntTabSheet1: TTntTabSheet;
    TntTabSheet4: TTntTabSheet;
    TntTabSheet5: TTntTabSheet;
    TableEngineComboBox: TTntComboBox;
    AdvancedOptionsScrollBox: TTntScrollBox;
    ScrollSpacerAdvOptShape: TTntShape;
    StorageOptionsGBox: TTntGroupBox;
    TntLabel27: TTntLabel;
    TntLabel28: TTntLabel;
    TntLabel55: TTntLabel;
    TntLabel56: TTntLabel;
    DataDirectoryEd: TTntEdit;
    IndexDirectoryEd: TTntEdit;
    RowOptionsGBox: TTntGroupBox;
    TntLabel22: TTntLabel;
    TntLabel24: TTntLabel;
    TntLabel25: TTntLabel;
    TntLabel26: TTntLabel;
    TntLabel39: TTntLabel;
    TntLabel60: TTntLabel;
    TntLabel61: TTntLabel;
    TntLabel62: TTntLabel;
    TntLabel63: TTntLabel;
    AvgRowLengthEd: TTntEdit;
    MinRowsEd: TTntEdit;
    MaxRowsEd: TTntEdit;
    UseChecksumCBox: TTntCheckBox;
    RowFormatComboBox: TTntComboBox;
    RaidOptionsGBox: TTntGroupBox;
    TntLabel29: TTntLabel;
    NumberOfChunksCaptionLbl: TTntLabel;
    ChunkSizeCaptionEd: TTntLabel;
    ChunkSizeUnitLbl: TTntLabel;
    TntLabel57: TTntLabel;
    NumberOfChunksDescLbl: TTntLabel;
    ChunkSizeDescLbl: TTntLabel;
    RaidTypeComboBox: TTntComboBox;
    NumberOfChunksEd: TTntEdit;
    ChunkSizeEd: TTntEdit;
    ChunkSizeUpDown: TTntUpDown;
    NumberOfChunksUpDown: TTntUpDown;
    VariousGBox: TTntGroupBox;
    TntLabel19: TTntLabel;
    TntLabel20: TTntLabel;
    TntLabel21: TTntLabel;
    TntLabel51: TTntLabel;
    TntLabel52: TTntLabel;
    TntLabel53: TTntLabel;
    TntLabel54: TTntLabel;
    PackKeysComboBox: TTntComboBox;
    AutoIncEd: TTntEdit;
    TablePasswordEd: TTntEdit;
    DelayKeyUpdatesCBox: TTntCheckBox;
    MergeOptionGBox: TTntGroupBox;
    MergeInsertMethodCapionLbl: TTntLabel;
    UnionTablesCaptionLbl: TTntLabel;
    UnionTablesDescLbl: TTntLabel;
    MergeInsertMethodDescLbl: TTntLabel;
    MergeInsertMethodComboBox: TTntComboBox;
    UnionTablesEd: TTntEdit;
    TntLabel1: TTntLabel;
    CharsetComboBox: TTntComboBox;
    CloseBtn: TTntButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TableNameEdChange(Sender: TObject);
    procedure TableEngineComboBoxCloseUp(Sender: TObject);
    procedure ColumnVSTInitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
    procedure ColumnVSTGetText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
      var CellText: WideString);
    procedure ColumnVSTFreeNode(Sender: TBaseVirtualTree;
      Node: PVirtualNode);
    procedure ColumnVSTAfterCellPaint(Sender: TBaseVirtualTree;
      TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      CellRect: TRect);
    procedure ColumnVSTGetImageIndex(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
      var Ghosted: Boolean; var ImageIndex: Integer);
    procedure ColumnVSTMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ColumnVSTEditing(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);
    procedure ColumnVSTNewText(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; NewText: WideString);
    procedure ColumnVSTCreateEditor(Sender: TBaseVirtualTree;
      Node: PVirtualNode; Column: TColumnIndex; out EditLink: IVTEditLink);
    procedure TableNameEdKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);

    procedure DoColumnGridEdit(var Message: TMessage); message WM_DoCellEdit;
    procedure ApplyChangesBtnClick(Sender: TObject);
    procedure DiscardChangesBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure ColumnVSTDragDrop(Sender: TBaseVirtualTree; Source: TObject;
      DataObject: IDataObject; Formats: TFormatArray; Shift: TShiftState;
      Pt: TPoint; var Effect: Integer; Mode: TDropMode);
    procedure ColumnVSTDragOver(Sender: TBaseVirtualTree; Source: TObject;
      Shift: TShiftState; State: TDragState; Pt: TPoint; Mode: TDropMode;
      var Effect: Integer; var Accept: Boolean);
  private
    { Private declarations }
    FEngineMapping: TTntStringList;

    FColumnPNGImg,
    FColumnFKPNGImg,
    FColumnPKPNGImg,
    FColumnPKFKPNGImg: TPNGObject;

    FIsNullPNGImg: TPNGObject;

    FCheckmarkPNGImg,
    FOptionsCheckboxPNGImg,
    FOptionsCheckboxCheckedPNGImg: TPNGObject;

    FDatatypeImgList: TList;

    FRdbms: Pointer;

    FColumnNameInitialText: WideString;
  protected
    procedure UpdateColumnNodeData(NodeData: PColumnNodeData);

    function SetColumnPK(NodeData: PColumnNodeData;
      IsPkColumn: Boolean): Boolean;

    procedure SetModified(Modified: Boolean); override;
  public
    { Public declarations }
    procedure SetRdbms(Rdbms: Pointer);
    procedure StartEditObject(Obj: Pointer); override;
    procedure EndEditObject; override;
  end;


var
  MyxTableEditorForm: TMyxTableEditorForm;

implementation

{$R *.dfm}

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.FormCreate(Sender: TObject);

begin
  FRdbms := nil;

  FColumnPNGImg := LoadPNGImageFromResource('column');
  FColumnFKPNGImg := LoadPNGImageFromResource('column_fk');
  FColumnPKPNGImg := LoadPNGImageFromResource('column_pk');
  FColumnPKFKPNGImg := LoadPNGImageFromResource('column_pk');

  FIsNullPNGImg := LoadPNGImageFromResource('field_overlay_null');

  FCheckmarkPNGImg := LoadPNGImageFromResource('checkmark');
  FOptionsCheckboxPNGImg := LoadPNGImageFromResource('options_checkbox');
  FOptionsCheckboxCheckedPNGImg := LoadPNGImageFromResource('options_checkbox_checked');

  FEngineMapping := TTntStringList.Create;
  TableEngineComboBox.Items.Clear;
  FEngineMapping.Add('InnoDB');
  TableEngineComboBox.Items.Add('Transactional (InnoDB)');
  FEngineMapping.Add('MyISAM');
  TableEngineComboBox.Items.Add('Non transactional (MyISAM)');
  FEngineMapping.Add('Memory');
  TableEngineComboBox.Items.Add('Memory only (Memory)');
  FEngineMapping.Add('Merge');
  TableEngineComboBox.Items.Add('Merge (Merge)');
  FEngineMapping.Add('NDB');
  TableEngineComboBox.Items.Add('Cluster (NDB)');
  FEngineMapping.Add('BDB');
  TableEngineComboBox.Items.Add('Berkeley DB (BDB)');

  // The order of the images has to match the RdbmsDatatypeGroup type
  FDatatypeImgList := TList.Create;
  FDatatypeImgList.Add(LoadPNGImageFromResource('datatype_numeric'));
  FDatatypeImgList.Add(LoadPNGImageFromResource('datatype_string'));
  FDatatypeImgList.Add(LoadPNGImageFromResource('datatype_text'));
  FDatatypeImgList.Add(LoadPNGImageFromResource('datatype_blob'));
  FDatatypeImgList.Add(LoadPNGImageFromResource('datatype_datetime'));
  FDatatypeImgList.Add(LoadPNGImageFromResource('datatype_spatial'));
  FDatatypeImgList.Add(LoadPNGImageFromResource('datatype_userdefined'));
  FDatatypeImgList.Add(LoadPNGImageFromResource('datatype_structured'));
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.FormDestroy(Sender: TObject);

var
  I: Integer;

begin
  FEngineMapping.Free;

  FCheckmarkPNGImg.Free;
  FOptionsCheckboxPNGImg.Free;
  FOptionsCheckboxCheckedPNGImg.Free;

  FColumnPNGImg.Free;
  FColumnFKPNGImg.Free;
  FColumnPKPNGImg.Free;

  FIsNullPNGImg.Free;

  for I := 0 to FDatatypeImgList.Count - 1 do
    TPNGObject(FDatatypeImgList[I]).Free;
  FDatatypeImgList.Free;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.FormClose(Sender: TObject;
  var Action: TCloseAction);

begin
  Action := caFree;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.SetRdbms(Rdbms: Pointer);

begin
  FRdbms := Rdbms;

  Grt.ValueRetain(FRdbms);
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.StartEditObject(Obj: Pointer);

var
  Schema: Pointer;

begin
  inherited;

  // Initialize editor

  // name
  TableNameEd.Text := Grt.DictString[Obj, 'name'];

  if (ObjStructName = 'db.mysql.Table') then
  begin
    // engine
    TableEngineComboBox.ItemIndex :=
      FEngineMapping.IndexOf(Grt.DictString[Obj, 'tableEngine']);
    TableEngineComboBox.Enabled := True;

    // character set / collation
    CharsetComboBox.Text :=
      Grt.DictString[Obj, 'defaultCollationName'];

    if (CharsetComboBox.Text = '') then
    begin
      Schema := Grt.DictRef[Obj, 'owner'];

      if (Schema <> nil) then
        CharsetComboBox.Text :=
          Grt.DictString[Schema, 'defaultCollationName'];
    end;

    if (CharsetComboBox.Text = '') then
      CharsetComboBox.Text := 'utf8_general_ci';
  end
  else
  begin
    TableEngineComboBox.ItemIndex := -1;
    TableEngineComboBox.Enabled := False;

    CharsetComboBox.ItemIndex := -1;
    CharsetComboBox.Enabled := False;
  end;

  // columns
  ColumnVST.NodeDataSize := sizeof(TColumnNodeData);

  ColumnVST.BeginUpdate;
  try
    ColumnVST.RootNodeCount :=
      Grt.ListCount(Grt.DictItem[Obj, 'columns']) + 1;
  finally
    ColumnVST.EndUpdate;
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.EndEditObject;

begin
  inherited;

  Grt.ValueRelease(FRdbms);
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.TableNameEdChange(Sender: TObject);

begin
  if (Grt.DictString[Obj, 'name'] <> TableNameEd.Text) then
  begin
    Grt.DictString[Obj, 'name'] := TableNameEd.Text;

    Modified := True;
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.TableEngineComboBoxCloseUp(Sender: TObject);

begin
  if (Grt.DictString[Obj, 'tableEngine'] <>
    FEngineMapping[TableEngineComboBox.ItemIndex]) then
  begin
    Grt.DictString[Obj, 'tableEngine'] :=
      FEngineMapping[TableEngineComboBox.ItemIndex];

    Modified := True;
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTInitNode(Sender: TBaseVirtualTree;
  ParentNode, Node: PVirtualNode;
  var InitialStates: TVirtualNodeInitStates);

var
  NodeData: PColumnNodeData;
  Columns: Pointer;

begin
  NodeData := Sender.GetNodeData(Node);

  Columns := Grt.DictItem[Obj, 'columns'];
  if (Node.Index < Cardinal(Grt.ListCount(Columns))) then
    NodeData.Column := Grt.ListItem[Columns, Node.Index];

  UpdateColumnNodeData(NodeData);
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.UpdateColumnNodeData(NodeData: PColumnNodeData);

var
  Column,
  FlagList,
  PrimaryKey,
  PrimaryKeyColumns: Pointer;
  Id: WideString;
  I: Integer;

begin
  Column := NodeData.Column;

  if (Column <> nil) then
  begin
    NodeData.Caption := Grt.DictString[Column, 'name'];

    // PK
    Id := Grt.DictString[Column, '_id'];
    NodeData.PrimaryKey := False;
    PrimaryKey := Grt.DictItem[Obj, 'primaryKey'];
    if (PrimaryKey <> nil) then
    begin
      PrimaryKeyColumns := Grt.DictItem[PrimaryKey, 'columns'];
      for I := 0 to Grt.ListCount(PrimaryKeyColumns) - 1 do
        if (Grt.ListString[PrimaryKeyColumns, I] = Id) then
        begin
          NodeData.PrimaryKey := True;
          break;
        end;
    end;

    // NN, AI
    NodeData.NotNull := (Grt.DictInt[Column, 'isNullable'] = 0);
    NodeData.AutoIncrement := (Grt.DictInt[Column, 'autoIncrement'] = 1);

    //Default value
    NodeData.DefaultIsNull := (Grt.DictInt[Column, 'defaultValueIsNull'] = 1);
    if (Not(NodeData.DefaultIsNull)) then
      NodeData.Default := Grt.DictString[Column, 'defaultValue'];

    // Comment
    NodeData.Comment := Grt.DictString[Column, 'comment'];

    // Datatype
    NodeData.DatatypeFullCaption :=
      Grt.DictString[Column, 'datatypeName'];

    NodeData.SimpleDatatype := Grt.DictRef[Column, 'simpleType'];
    NodeData.StructuredDatatype := Grt.DictRef[Column, 'structuredDatatype'];
    if (NodeData.SimpleDatatype <> nil) then
    begin
      Id := Grt.DictString[NodeData.SimpleDatatype, 'group'];

      if (Id = '{A0B5D6E6-E94C-482A-8608-8EF7AF4FB560}') then
        NodeData.DatatypeGroup := RDG_NUMERIC
      else
        if (Id = '{92F0945A-4658-47A0-A3EA-423F4AB13694}') then
          NodeData.DatatypeGroup := RDG_STRING
        else
          if (Id = '{F48E12A6-C67D-43EC-8FA6-EC30D75E5528}') then
            NodeData.DatatypeGroup := RDG_TEXT
          else
            if (Id = '{640A39CD-A559-4366-BBCD-734F638B361D}') then
              NodeData.DatatypeGroup := RDG_BLOB
            else
              if (Id = '{06431E19-2E93-4DE3-8487-A8DF4A25DA96}') then
                NodeData.DatatypeGroup := RDG_DATETIME
              else
                if (Id = '{C1ABB46A-9AF9-420C-B31B-95AFE921C085}') then
                  NodeData.DatatypeGroup := RDG_GEO
                else
                  if (Id = '{BBE4BC2C-D462-46B7-AC2E-9F0CE17C3686}') then
                    NodeData.DatatypeGroup := RDG_VARIOUS
                  else
                    if (Id = '{3D44C889-03BA-4783-A02D-ACDF4943257E}') then
                      NodeData.DatatypeGroup := RDG_USER;

      // Set precision, scale, length
      if (Grt.DictInt[NodeData.SimpleDatatype, 'numericPrecision'] > 0) then
      begin
        if (Grt.DictInt[Column, 'scale'] <> 0) then
          NodeData.DatatypeFullCaption :=
            NodeData.DatatypeFullCaption + '(' +
            IntToStr(Grt.DictInt[Column, 'precision']) + ', ' +
            IntToStr(Grt.DictInt[Column, 'scale']) + ')'
        else
          NodeData.DatatypeFullCaption :=
            NodeData.DatatypeFullCaption + '(' +
            IntToStr(Grt.DictInt[Column, 'precision']) + ')';
      end
      else
        if (Grt.DictInt[NodeData.SimpleDatatype, 'characterMaximumLength'] > 0) then
        begin
          NodeData.DatatypeFullCaption :=
            NodeData.DatatypeFullCaption + '(' +
            IntToStr(Grt.DictInt[Column, 'length']) + ')';
        end
        else
          if (Grt.DictString[Column, 'datatypeExplicitParams'] <> '') then
          begin
            NodeData.DatatypeFullCaption :=
              NodeData.DatatypeFullCaption +
              Grt.DictString[Column, 'datatypeExplicitParams'];
          end;
    end
    else
      if (NodeData.StructuredDatatype <> nil) then
      begin
        NodeData.DatatypeGroup := RDG_STRUCTURED;
      end
      else
      begin
        // if no simple or structured datatype is set,
        // simply take the parameters
        if (Grt.DictInt[Column, 'length'] <> 0) then
        begin
          NodeData.DatatypeFullCaption :=
            NodeData.DatatypeFullCaption + '(' +
            IntToStr(Grt.DictInt[Column, 'length']) + ')';
        end
        else
          if (Grt.DictInt[Column, 'precision'] <> 0) then
          begin
            if (Grt.DictInt[Column, 'scale'] <> 0) then
              NodeData.DatatypeFullCaption :=
                NodeData.DatatypeFullCaption + '(' +
                IntToStr(Grt.DictInt[Column, 'precision']) + ', ' +
                IntToStr(Grt.DictInt[Column, 'scale']) + ')'
            else
              NodeData.DatatypeFullCaption :=
                NodeData.DatatypeFullCaption + '(' +
                IntToStr(Grt.DictInt[Column, 'precision']) + ')';
          end
          else
            if (Grt.DictString[Column, 'datatypeExplicitParams'] <> '') then
            begin
              NodeData.DatatypeFullCaption :=
                NodeData.DatatypeFullCaption +
                Grt.DictString[Column, 'datatypeExplicitParams'];
            end;
      end;
  end;

  // All available datatype flags
  if (NodeData.DatatypeFlags = nil) then
    NodeData.DatatypeFlags := TTntStringList.Create
  else
    NodeData.DatatypeFlags.Clear;

  if (NodeData.SimpleDatatype <> nil) then
  begin
    FlagList := Grt.DictItem[NodeData.SimpleDatatype, 'flags'];
    for I := 0 to Grt.ListCount(FlagList) - 1 do
      NodeData.DatatypeFlags.Add(Grt.ListString[FlagList, I]);
  end;

  // All set datatype flags
  if (NodeData.ColumnFlags = nil) then
    NodeData.ColumnFlags := TTntStringList.Create
  else
    NodeData.ColumnFlags.Clear;

  if (NodeData.Column <> nil) then
  begin
    FlagList := Grt.DictItem[NodeData.Column, 'flags'];
    for I := 0 to Grt.ListCount(FlagList) - 1 do
      NodeData.ColumnFlags.Add(Grt.ListString[FlagList, I]);
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTFreeNode(Sender: TBaseVirtualTree;
  Node: PVirtualNode);

var
  NodeData: PColumnNodeData;

begin
  NodeData := Sender.GetNodeData(Node);

  NodeData.DatatypeFlags.Free;
  NodeData.ColumnFlags.Free;

  Finalize(NodeData^);
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);

var
  NodeData: PColumnNodeData;

begin
  NodeData := Sender.GetNodeData(Node);

  case Column of
    0: CellText := NodeData.Caption;
    1: CellText := NodeData.DatatypeFullCaption;
    5: CellText := NodeData.Default;
    6: CellText := NodeData.Comment;
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTAfterCellPaint(
  Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode;
  Column: TColumnIndex; CellRect: TRect);

var
  NodeData: PColumnNodeData;
  I, P, L: integer;
  S: WideString;

begin
  NodeData := Sender.GetNodeData(Node);

  if (NodeData.Column = nil) then
    Exit;

  case Column of
    0:
      if (Not(NodeData.PrimaryKey)) and (Not(NodeData.ForeignKey)) then
        FColumnPNGImg.Draw(TargetCanvas, Rect(CellRect.Left + 1,
          CellRect.Top + 1, CellRect.Left + 17, CellRect.Top + 17))
      else
        if (NodeData.PrimaryKey) and (Not(NodeData.ForeignKey)) then
          FColumnPKPNGImg.Draw(TargetCanvas, Rect(CellRect.Left + 1,
            CellRect.Top + 1, CellRect.Left + 17, CellRect.Top + 17))
        else
          if (NodeData.PrimaryKey) and (NodeData.ForeignKey) then
            FColumnPKFKPNGImg.Draw(TargetCanvas, Rect(CellRect.Left + 1,
              CellRect.Top + 1, CellRect.Left + 17, CellRect.Top + 17))
          else
            FColumnFKPNGImg.Draw(TargetCanvas, Rect(CellRect.Left + 1,
              CellRect.Top + 1, CellRect.Left + 17, CellRect.Top + 17));
    1:
      if (Ord(NodeData.DatatypeGroup) < FDatatypeImgList.Count) then
        TPNGObject(FDatatypeImgList[Ord(NodeData.DatatypeGroup)]).Draw(
          TargetCanvas, Rect(CellRect.Left+1,
          CellRect.Top+1, CellRect.Left+17, CellRect.Top+17))
      else
        TPNGObject(FDatatypeImgList[FDatatypeImgList.Count - 2]).Draw(
          TargetCanvas, Rect(CellRect.Left+1,
          CellRect.Top+1, CellRect.Left+17, CellRect.Top+17));
    2:
      //Not null checkmark
      if (NodeData.NotNull) then
        FCheckmarkPNGImg.Draw(TargetCanvas, Rect(CellRect.Left+5,
          CellRect.Top+1, CellRect.Left+21, CellRect.Top+17));
    3:
      //Auto Increment checkmark
      if (NodeData.AutoIncrement) then
        FCheckmarkPNGImg.Draw(TargetCanvas, Rect(CellRect.Left+5,
          CellRect.Top+1, CellRect.Left+21, CellRect.Top+17));
    4:
      begin
        P:=5;

        SetBkMode(TargetCanvas.Handle, TRANSPARENT);
        TargetCanvas.Font.Color:=clBlack;

        for I := 0 to NodeData.DatatypeFlags.Count - 1 do
        begin
          S := NodeData.DatatypeFlags[I];

          if (NodeData.ColumnFlags.IndexOf(S) > -1) then
            FOptionsCheckboxCheckedPNGImg.Draw(TargetCanvas,
              Rect(CellRect.Left + P, CellRect.Top + 1,
                CellRect.Left + 16 + P, CellRect.Top + 17))
          else
            FOptionsCheckboxPNGImg.Draw(TargetCanvas,
              Rect(CellRect.Left + P, CellRect.Top + 1,
                CellRect.Left + 16 + P, CellRect.Top + 17));

          P := P + 16 + 5;
          L := GetWideStringTextWidth(TargetCanvas, S);

          DrawWideStringText(TargetCanvas.Handle,
            PWideChar(S),
            Length(S),
            Rect(CellRect.Left + P, CellRect.Top + 2,
              CellRect.Left + P + L, CellRect.Top + 16));

          P := P + L + 10;
        end;
      end;
    5:
      if (NodeData.DefaultIsNull) then
        FIsNullPNGImg.Draw(TargetCanvas,
          Rect(CellRect.Left + 2, CellRect.Top + 2,
            CellRect.Left + 2 + FIsNullPNGImg.Width,
            CellRect.Top + 2 + FIsNullPNGImg.Height));
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTGetImageIndex(
  Sender: TBaseVirtualTree; Node: PVirtualNode; Kind: TVTImageKind;
  Column: TColumnIndex; var Ghosted: Boolean; var ImageIndex: Integer);

begin
  if (Column <= 1) then
    ImageIndex := 0;
end;

// -----------------------------------------------------------------------------

function TMyxTableEditorForm.SetColumnPK(NodeData: PColumnNodeData;
  IsPkColumn: Boolean): Boolean;

var
  PrimaryKey,
  PKColumns: Pointer;
  StructName: WideString;

begin
  Result := False;

  if (NodeData.PrimaryKey) and (Not(IsPkColumn)) then
  begin
    PrimaryKey := Grt.DictItem[Obj, 'primaryKey'];

    if (PrimaryKey <> nil) then
    begin
      PKColumns := Grt.DictItem[PrimaryKey, 'columns'];

      Grt.ListDelString(PKColumns,
        Grt.DictString[NodeData.Column, '_id']);

      // if there are no more columns left,
      // remove to PK completely
      if (Grt.ListCount(PKColumns) = 0) then
        Grt.DictDel(Obj, 'primaryKey');
    end;

    NodeData.PrimaryKey := False;

    Result := True;
  end
  else
    if (Not(NodeData.PrimaryKey)) and (IsPkColumn) then
    begin
      PrimaryKey := Grt.DictItem[Obj, 'primaryKey'];

      // Create PK if it is not already there
      if (PrimaryKey = nil) then
      begin
        StructName := Grt.GetStructMemberStructName(
          ObjStructName, 'primaryKey');

        PrimaryKey := Grt.ObjectNew(StructName,
          'PRIMARY', '', Grt.DictString[Obj, '_id']);
      end;

      PKColumns := Grt.DictItem[PrimaryKey, 'columns'];

      // Add column's _id to the primaryKey's columns list
      Grt.ListAdd(PKColumns, Grt.ValueFromString(
        Grt.DictString[NodeData.Column, '_id']));

      NodeData.PrimaryKey := True;

      Result := True;
    end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

var HitInfo: THitInfo;
  CLeft, CRight: integer;
  NodeData: PColumnNodeData;
  Xpos,
  I,
  L,
  FlagIndex: integer;
  S: WideString;

begin
  ColumnVST.GetHitTestInfoAt(X, Y, True, HitInfo);

  if (HitInfo.HitNode = nil) then
    Exit;

  case HitInfo.HitColumn of
    0: //Switch Primary Key
      begin
        ColumnVST.Header.Columns.GetColumnBounds(HitInfo.HitColumn,
          CLeft, CRight);

        if (X<16) then
        begin
          NodeData := ColumnVST.GetNodeData(HitInfo.HitNode);

          Modified := SetColumnPK(NodeData, Not(NodeData.PrimaryKey));

          ColumnVST.InvalidateNode(HitInfo.HitNode);
        end;
      end;
    2: // Switch NotNull
      begin
        NodeData := ColumnVST.GetNodeData(HitInfo.HitNode);

        NodeData.NotNull := Not(NodeData.NotNull);

        Grt.DictInt[NodeData.Column, 'isNullable'] :=
          Ord(Not(NodeData.NotNull));

        Modified := True;

        ColumnVST.InvalidateNode(HitInfo.HitNode);
        //SetCurrentColumn(CurrentColumn);
      end;
    3: // Switch AutoIncrement
      begin
        NodeData := ColumnVST.GetNodeData(HitInfo.HitNode);

        NodeData.AutoIncrement := Not(NodeData.AutoIncrement);

        Grt.DictInt[NodeData.Column, 'autoIncrement'] :=
          Ord(NodeData.AutoIncrement);

        Modified := True;

        ColumnVST.InvalidateNode(HitInfo.HitNode);
        //SetCurrentColumn(CurrentColumn);
      end;
    4: //Switch Datatype Flags
      begin
        ColumnVST.Header.Columns.GetColumnBounds(HitInfo.HitColumn,
          CLeft, CRight);

        Xpos:=5;

        NodeData:=ColumnVST.GetNodeData(HitInfo.HitNode);
        for I:=0 to NodeData.DatatypeFlags.Count - 1 do
        begin
          S := NodeData.DatatypeFlags[I];

          L := GetWideStringTextWidth(ColumnVST.Canvas, S);

          if (X>=CLeft + Xpos) and
            (X<=CLeft + Xpos + 16 + 5 + L + 10)then
          begin
            FlagIndex := NodeData.ColumnFlags.IndexOf(S);

            // Handle flag toggle
            if (FlagIndex = -1) then
            begin
              //Special processing for CHAR
              if (CompareText(Grt.DictString[
                NodeData.SimpleDatatype, 'name'], 'CHAR') = 0) then
              begin
                if (CompareText(S, 'ASCII') = 0) then
                  if(NodeData.ColumnFlags.IndexOf('UNICODE')>-1)then
                    NodeData.ColumnFlags.Delete(
                      NodeData.ColumnFlags.IndexOf('UNICODE'));
                if(CompareText(s, 'UNICODE')=0)then
                  if(NodeData.ColumnFlags.IndexOf('ASCII')>-1)then
                    NodeData.ColumnFlags.Delete(
                      NodeData.ColumnFlags.IndexOf('ASCII'));

              end;

              NodeData.ColumnFlags.Add(s);
            end
            else
              NodeData.ColumnFlags.Delete(FlagIndex);

            Modified:=True;

            ColumnVST.InvalidateNode(HitInfo.HitNode);
            //SetCurrentColumn(CurrentColumn);

            break;
          end;

          Xpos := Xpos + 16 + 5 + L + 10;
        end;
      end;
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTEditing(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; var Allowed: Boolean);

begin
  if (Column<=1) or (Column >= 5) then
    Allowed := True
  else
    Allowed := False;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTNewText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; NewText: WideString);

var
  NodeData: PColumnNodeData;
  StructName: WideString;
  Columns: Pointer;
  DatatypeName: WideString;

begin
  NodeData := Sender.GetNodeData(Node);

  if (Trim(NewText) <> '') or (Column = 5) or (Column = 6) then
  begin
    Modified:=True;

    //Add new column
    if (NodeData.Column = nil) then
    begin
      StructName := Grt.GetStructMemberContentStructName(
        ObjStructName, 'columns');

      NodeData.Column := Grt.ObjectNew(StructName, 'new_column',
        '', Grt.DictString[Obj, '_id']);

      DatatypeName := 'INT';

      Grt.DictString[NodeData.Column, 'datatypeName'] := DatatypeName;

      if (FRdbms <> nil) then
        Grt.DictString[NodeData.Column, 'simpleType'] :=
          Grt.DictString[
            Grt.ListItemByObjectName[
              Grt.DictItem[FRdbms, 'simpleDatatypes'],
              DatatypeName],
            '_id'];


      Grt.DictInt[NodeData.Column, 'defaultValueIsNull'] := 1;
      Grt.DictInt[NodeData.Column, 'precision'] := 11;

      Columns := Grt.DictItem[Obj, 'columns'];
      if (Grt.ListCount(Columns) = 0) then
      begin
        Grt.DictInt[NodeData.Column, 'isNullable'] := 0;
        Grt.DictInt[NodeData.Column, 'autoIncrement'] := 1;

        Grt.DictInt[NodeData.Column, 'unsigned'] := 1;
        Grt.ListAdd(Grt.DictItem[NodeData.Column, 'flags'],
          Grt.ValueFromString('UNSIGNED'));
      end
      else
        Grt.DictInt[NodeData.Column, 'isNullable'] := 1;

      UpdateColumnNodeData(NodeData);

      if (Grt.ListCount(Columns) = 0) then
        SetColumnPK(NodeData, True);

      Grt.ListAdd(Grt.DictItem[Obj, 'columns'], NodeData.Column);

      ColumnVST.RootNodeCount := ColumnVST.RootNodeCount + 1;
    end;

    case Column of
      0:
        Grt.DictString[NodeData.Column, 'name'] := NewText;
      1:
        Grt.ExecuteModalProcedure(
          'DbUtils',
          'setColumnDatatypeByString',
          [FRdbms, NodeData.Column, WideUpperCase(NewText)]);
      5:
        Grt.DictString[NodeData.Column, 'defaultValue'] := NewText;
      6:
        Grt.DictString[NodeData.Column, 'comment'] := NewText;
    end;

    UpdateColumnNodeData(NodeData);

    ColumnVST.InvalidateNode(Node);
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTCreateEditor(
  Sender: TBaseVirtualTree; Node: PVirtualNode; Column: TColumnIndex;
  out EditLink: IVTEditLink);

begin
  EditLink:=TColumnGridEditLink.Create(FRdbms, FColumnNameInitialText);

  FColumnNameInitialText:='';
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.TableNameEdKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);

var
  Mgs: TMsg;
  Columns: Pointer;

begin
  if (Key = VK_Return) then
  begin
    Columns := Grt.DictItem[Obj, 'columns'];
    if (Grt.ListCount(Columns) = 0) then
    begin
      ColumnVST.SetFocus;
      ColumnVST.FocusedNode := ColumnVST.GetFirst;
      ColumnVST.ClearSelection;

      if(ColumnVST.FocusedNode<>nil)then
      begin
        ColumnVST.Selected[ColumnVST.FocusedNode] := True;

        FColumnNameInitialText := ReplaceTags(
          AppOptions.OptionString['PkColumnNameTemplate'],
          '%tablename%='+TableNameEd.Text);

        ColumnVST.EditNode(ColumnVST.FocusedNode, 0);
      end;
    end;

    Key:=0;
    PeekMessage(Mgs, 0, WM_CHAR, WM_CHAR, PM_REMOVE);
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.DoColumnGridEdit(var Message: TMessage);

begin
  if (HWND(Message.WParam) = ColumnVST.Handle) then
  begin
    if (ColumnVST.FocusedNode = nil) then
      ColumnVST.FocusedNode := ColumnVST.GetFirst;

    if (ColumnVST.FocusedNode <> nil) then
      ColumnVST.EditNode(ColumnVST.FocusedNode, ColumnVST.FocusedColumn);
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ApplyChangesBtnClick(Sender: TObject);

begin
  ApplyChanges;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.DiscardChangesBtnClick(Sender: TObject);

begin
  DiscardChanges;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.SetModified(Modified: Boolean);

begin
  inherited;

  ApplyChangesBtn.Enabled := Modified;
  DiscardChangesBtn.Enabled := Modified;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.CloseBtnClick(Sender: TObject);

begin
  Close;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTDragDrop(Sender: TBaseVirtualTree;
  Source: TObject; DataObject: IDataObject; Formats: TFormatArray;
  Shift: TShiftState; Pt: TPoint; var Effect: Integer; Mode: TDropMode);

var
  I: Integer;
  StartIndexOriginal,
  StartIndexColumnList: Integer;
  NodeData: PColumnNodeData;
  Selection: TNodeArray;
  ColumnList: Pointer;

begin
  Selection := nil;

  // re-ordering of columns
  if (Source = ColumnVST) and (Sender.DropTargetNode <> nil) then
  begin
    Selection := ColumnVST.GetSortedSelection(False);
    if (Mode = dmAbove) then
      StartIndexOriginal := Sender.DropTargetNode.Index - 1
    else
      StartIndexOriginal := Sender.DropTargetNode.Index;
    StartIndexColumnList := StartIndexOriginal;

    ColumnList := Grt.DictItem[Obj, 'columns'];

    for I := 0 to Sender.SelectedCount - 1 do
    begin
      NodeData := Sender.GetNodeData(Selection[I]);

      // if a column from above the StartIndex is moved
      if (Integer(Selection[I].Index) < StartIndexOriginal) then
      begin
        //add the column after the StartIndexColumnList
        Grt.ListInsert(ColumnList, StartIndexColumnList + 1 + I,
          NodeData.Column);
        //remove column at original position
        Grt.ListDel(ColumnList, Selection[I].Index);

        //move StartIndexColumnList one up since a column
        //from above was moved below the column
        dec(StartIndexColumnList);
      end
      else
        // if a column from below the StartIndex is moved
        if (Integer(Selection[I].Index) > StartIndexOriginal) then
        begin
          //add the column after the StartIndexColumnList
          Grt.ListInsert(ColumnList, StartIndexColumnList + 1 + I,
            NodeData.Column);
          //remove column at original position
          Grt.ListDel(ColumnList, Selection[I].Index);
        end;
    end;

    // rebuild columns
    ColumnVST.BeginUpdate;
    try
      ColumnVST.Clear;
      ColumnVST.RootNodeCount :=
        Grt.ListCount(ColumnList) + 1;
    finally
      ColumnVST.EndUpdate;
    end;
  end;
end;

// -----------------------------------------------------------------------------

procedure TMyxTableEditorForm.ColumnVSTDragOver(Sender: TBaseVirtualTree;
  Source: TObject; Shift: TShiftState; State: TDragState; Pt: TPoint;
  Mode: TDropMode; var Effect: Integer; var Accept: Boolean);

begin
  if (Source = ColumnVST) then
    Accept := True;
end;

// -----------------------------------------------------------------------------

end.
